<template>
  <div>
    <div class="search">
      <el-input placeholder="请输入关键字查询" style="width: 200px" v-model="username"></el-input>
      <el-button type="info" plain style="margin-left: 10px" @click="load(1)">查询</el-button>
      <el-button type="warning" plain style="margin-left: 10px" @click="reset">重置</el-button>
    </div>

    <div class="operation">
      <el-button type="primary" plain @click="handleAdd">新增</el-button>
      <el-button type="danger" plain @click="delBatch">批量删除</el-button>
    </div>

    <div class="table">
      <el-table v-loading="isLoading" :data="tableData" strip @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center"></el-table-column>
        <el-table-column prop="id" label="序号" width="70" align="center" sortable></el-table-column>
        <el-table-column prop="storeAddress" label="店铺地址"></el-table-column>
        <el-table-column prop="idcard" label="身份证"></el-table-column>
        <el-table-column prop="businessLicense" label="营业执照url">
          <template v-slot="scope">
            <img style="width: 100%" :src="scope.row.businessLicense" @click="print(scope)"><img/>
          </template>
        </el-table-column>
        <el-table-column prop="reason" label="申请理由"></el-table-column>
        <el-table-column prop="picsUrl" label="市区营业图片">
          <template v-slot="scope" >
            <img style="width: 100%" :src="scope.row.picsUrl">
          </template>
        </el-table-column>
        <el-table-column prop="cameraUrl" label="监控地址"></el-table-column>
        <el-table-column prop="storeId" label="店铺申请人id用adminstore的id"></el-table-column>
        <el-table-column prop="keeperName" label="店铺主名称"></el-table-column>
        <el-table-column prop="state" label="审核状态">
          <template v-slot="scope">
            <el-tag :type="getTagType(scope.row.state)">
              {{scope.row.state}}
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="180">
          <template v-slot="scope">
            <el-button size="mini" type="primary" plain @click="handleEdit(scope.row)">编辑</el-button>
            <el-button size="mini" type="danger" plain @click="del(scope.row.id)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <div class="pagination">
        <el-pagination
            background
            @current-change="handleCurrentChange"
            :current-page="pageNum"
            :page-sizes="[5, 10, 20]"
            :page-size="pageSize"
            layout="total, prev, pager, next"
            :total="total">
        </el-pagination>
      </div>
    </div>

    <el-dialog title="申请审核表" :visible.sync="fromVisible" width="40%" :close-on-click-modal="false" destroy-on-close>
      <el-form :model="form" label-width="100px" style="padding-right: 50px" :rules="rules" ref="formRef">
        <el-form-item label="店铺地址" prop="storeAddress">
          <el-input v-model="form.storeAddress" placeholder="店铺地址"></el-input>
        </el-form-item>
        <el-form-item label="身份证" prop="idcard">
          <el-input v-model="form.idcard" placeholder="身份证"></el-input>
        </el-form-item>
        <el-form-item label="营业执照url" prop="businessLicense">
          <el-input v-model="form.businessLicense" placeholder="营业执照url"></el-input>
        </el-form-item>
        <el-form-item label="申请理由" prop="reason">
          <el-input v-model="form.reason" placeholder="申请理由"></el-input>
        </el-form-item>
        <el-form-item label="市区营业图片" prop="picsUrl">
          <el-input v-model="form.picsUrl" placeholder="市区营业图片"></el-input>
        </el-form-item>
        <el-form-item label="监控地址" prop="cameraUrl">
          <el-input v-model="form.cameraUrl" placeholder="监控地址"></el-input>
        </el-form-item>
        <el-form-item label="店铺申请人id用adminstore的id" prop="storeId">
          <el-input v-model="form.storeId" placeholder="店铺申请人id用adminstore的id"></el-input>
        </el-form-item>
        <el-form-item label="店铺主名称" prop="keeperName">
          <el-input v-model="form.keeperName" placeholder="店铺主名称"></el-input>
        </el-form-item>
        <el-form-item label="审核状态" prop="state">
          <el-input v-model="form.state" placeholder="审核状态"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="fromVisible = false">取 消</el-button>
        <el-button type="primary" @click="save">确 定</el-button>
      </div>
    </el-dialog>


  </div>
</template>
<script>
export default {
  name: "Audits",
  data() {
    return {
      isLoading: false,
      tableData: [],  // 所有的数据
      pageNum: 1,   // 当前的页码
      pageSize: 10,  // 每页显示的个数
      total: 0,
      username: null,
      fromVisible: false,
      form: {},
      user: JSON.parse(localStorage.getItem('xm-user') || '{}'),
      rules: {
      },
      ids: []
    }
  },
  created() {
    this.load(1)
  },
  methods: {
    handleAdd() {   // 新增数据
      this.form = {}  // 新增数据的时候清空数据
      this.fromVisible = true   // 打开弹窗
    },
    handleEdit(row) {   // 编辑数据
      this.form = JSON.parse(JSON.stringify(row))  // 给form对象赋值  注意要深拷贝数据
      this.fromVisible = true   // 打开弹窗
    },
    save() {   // 保存按钮触发的逻辑  它会触发新增或者更新
      this.$refs.formRef.validate((valid) => {
        if (valid) {
          this.$request({
            url: this.form.id ? '/audits/update' : '/audits/add',
            method: this.form.id ? 'PUT' : 'POST',
            data: this.form
          }).then(res => {
            if (res.code === '200') {  // 表示成功保存
              this.$message.success('保存成功')
              this.load(1)
              this.fromVisible = false
            } else {
              this.$message.error(res.msg)  // 弹出错误的信息
            }
          })
        }
      })
    },
    del(id) {   // 单个删除
      this.$confirm('您确定删除吗？', '确认删除', {type: "warning"}).then(response => {
        this.$request.delete('/audits/delete/' + id).then(res => {
          if (res.code === '200') {   // 表示操作成功
            this.$message.success('操作成功')
            this.load(1)
          } else {
            this.$message.error(res.msg)  // 弹出错误的信息
          }
        })
      }).catch(() => {
      })
    },
    handleSelectionChange(rows) {   // 当前选中的所有的行数据
      this.ids = rows.map(v => v.id)
    },
    delBatch() {   // 批量删除
      if (!this.ids.length) {
        this.$message.warning('请选择数据')
        return
      }
      this.$confirm('您确定批量删除这些数据吗？', '确认删除', {type: "warning"}).then(response => {
        this.$request.delete('/audits/delete/batch', {data: this.ids}).then(res => {
          if (res.code === '200') {   // 表示操作成功
            this.$message.success('操作成功')
            this.load(1)
          } else {
            this.$message.error(res.msg)  // 弹出错误的信息
          }
        })
      }).catch(() => {
      })
    },
    load(pageNum) {  // 分页查询
      if (pageNum) this.pageNum = pageNum
      this.$request.get('/audits/selectPage', {
        params: {
          pageNum: this.pageNum,
          pageSize: this.pageSize,
          username: this.username,
        }
      }).then(res => {
        this.tableData = res.data?.list
        this.total = res.data?.total
        console.log(this.tableData)
        this.isLoading = false;
      })
    },
    reset() {
      this.username = null
      this.load(1)
    },
    handleCurrentChange(pageNum) {
      this.load(pageNum)
    },
    print(data){
      console.log("print",data);
    },
    getTagType(data){
      let result = ""
      if(data == '正在审核') {result = "info"}
      else if(data == '审核通过') result = 'success'
      else if(data == '审核失败') result = 'danger'
      return result
      // return "success" | "info" | "warning"| "danger"
    }
  }
}
</script>

<style scoped>

</style>